//+------------------------------------------------------------------+
//|                                               ControllsCheck.mq4 |
//|                                 Copyright  2011, XrustSolution. |
//|                                           mail: xrustx@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, XrustSolution."
#property link      "mail: xrustx@gmail.com"
#include <ControlsComm.mqh>
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void start(){string iNm = "show";
	//---- -------------------------------------+
	//		     .  ,    
	//	  ,    .       
	//	,     .
	//----  
 	ArrayResize(GcontNms,5);
 	ArrayResize(GcontDat,5);
	//---- 
	//   			 				 						     
	GcontNms[0][0] = "cnt1";GcontNms[0][1] = "";				GcontNms[0][2] = "Wingdings";	GcontNms[0][3] = "";
	GcontNms[1][0] = "cnt2";GcontNms[1][1] = "SET_V_LINE";	GcontNms[1][2] = "Arial";		GcontNms[1][3] = "";
	GcontNms[2][0] = "cnt3";GcontNms[2][1] = "SET_H_LINE";	GcontNms[2][2] = "Arial";		GcontNms[2][3] = "";
	GcontNms[3][0] = "cnt4";GcontNms[3][1] = "TRIGGER";		GcontNms[3][2] = "Arial";		GcontNms[3][3] = "Arial black";
	GcontNms[4][0] = "cnt5";GcontNms[4][1] = "DEL OBJECT";	GcontNms[4][2] = "Arial";		GcontNms[4][3] = "";
	//---- 
	// X_DISTANCE			Y_DISTANCE				CORNER				FONT SIZE				COLOR						TRIGGER COLOR	
	GcontDat[0][0] = 10;GcontDat[0][1] = 10;GcontDat[0][2] = 0;GcontDat[0][3] = 11;GcontDat[0][4] = Red; GcontDat[0][5] = EMPTY;
	GcontDat[1][0] = 10;GcontDat[1][1] = 30;GcontDat[1][2] = 0;GcontDat[1][3] = 11;GcontDat[1][4] = Lime;GcontDat[1][5] = EMPTY;
	GcontDat[2][0] = 10;GcontDat[2][1] = 50;GcontDat[2][2] = 0;GcontDat[2][3] = 11;GcontDat[2][4] = Lime;GcontDat[2][5] = EMPTY;
	GcontDat[3][0] = 10;GcontDat[3][1] = 70;GcontDat[3][2] = 0;GcontDat[3][3] = 11;GcontDat[3][4] = Lime;GcontDat[3][5] = Red;
	GcontDat[4][0] = 10;GcontDat[4][1] = 90;GcontDat[4][2] = 0;GcontDat[4][3] = 11;GcontDat[4][4] = Lime;GcontDat[4][5] = EMPTY;
	//---- ------------------------------------------+
   SetControls(0);//  
   //----
   while(!IsStopped()){
   	int comm = GetControls(0,true);//    
   	if(comm!=0){
   		Comment("Last command = ",comm
   					,"   X_DISTANCE = ",GcontPos[0]
   					,"   Y_DISTANCE = ",GcontPos[1]
   					,"   TIME  = ",TimeToStr(GcontPos[2])
   					,"   PRICE = ",DoubleToStr(GcontPos[3],Digits)
   					);
   		ObjectDelete(iNm);			
			if(comm==1){//  
				ObjectCreate (iNm,OBJ_LABEL,0,0,0);
				ObjectSet(iNm,OBJPROP_XDISTANCE,GcontPos[0]-13);
				ObjectSet(iNm,OBJPROP_YDISTANCE,GcontPos[1]-15);
				ObjectSetText(iNm,"",24,"Wingdings",Red);
				WindowRedraw();
			}
			if(comm==2){//  
				ObjectCreate (iNm,OBJ_VLINE,0,0,0);
				ObjectSet(iNm,OBJPROP_TIME1,GcontPos[2]);
				ObjectSet(iNm,OBJPROP_COLOR,Yellow);
				WindowRedraw();
			}
			if(comm==3){//  
				ObjectCreate (iNm,OBJ_HLINE,0,0,0);
				ObjectSet(iNm,OBJPROP_PRICE1,GcontPos[3]);
				ObjectSet(iNm,OBJPROP_COLOR,Red);
				WindowRedraw();
			}
			if(comm==4){ObjectDelete(iNm); WindowRedraw();}	//  					
   	}
   	//   () -   ,     
   	Sleep(100);
   }
   //----
   DelControls(0);//   
	//----
return;}
//+------------------------------------------------------------------+