//+------------------------------------------------------------------+
//|                                                 ControlsComm.mq4 |
//|                                 Copyright  2011, XrustSolution. |
//|                                           mail: xrustx@gmail.com |
//+------------------------------------------------------------------+
//|      	|
//|      	|
//|MetaTrader4.      ()	|
//|  ().								|
//+------------------------------------------------------------------+
//|	   :												|
//|1)       			|
//|2)      ()		|
//|3)       			|
//|4)      : , \ |
//|5)      : 						|
//|			      () |	 	
//|	    ,   			|
//|       	|
//|,      						|	
//|1)	 DelControls(wnd) -     			|
//|2)  SetControls(wnd) -  ()    |
//|     								|
//|3)  GetControls(wnd,activate) -   ,  "0"	|
//|		    (    )		|
//|	      	   |
//|		        	|
//|		 ,     			|
//|	         		|
//|	     GcontPos[4]   		|
//|	 		GcontPos[0] = X_DISTANCE											|
//|	 		GcontPos[0] = Y_DISTANCE											|
//|	 		GcontPos[0] = TIME  (in timedate format)						|
//|	 		GcontPos[0] = PRICE (Bid) 											|
//|	 bool activate -      true 	|
//|		    ,   	|
//|		      			|
//|		 ,    ,   		|
//|		   .     |
//|		.																	|
//+------------------------------------------------------------------+
//|        		|
//|        .					|		
//+------------------------------------------------------------------+
//|	#include<ControlsComm.mqh>													|
//|	DelControls(wnd);																|
//|	SetControls(wnd);																|
//|	GetControls(wnd);																|
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, XrustSolution."
#property link      "mail: xrustx@gmail.com"
//+------------------------------------------------------------------+
//|       
//|      
//| .     : 
//+------------------------------------------------------------------+
string	GcontNms[1][4] = {"control_1",										//    
									"Control_1",										//   (    )
									"Arial",												//   
									""														//        (\)
									};														// -      ,   (  )
//+------------------------------------------------------------------+
//|      
//|    :
//+------------------------------------------------------------------+
int		GcontDat[1][6] = {10,													//    X_DISTANCE
									10,													//   Y Y_DISTANCE
									0 ,													//    0=|1=|2=|3=
									11,													//   
								 Lime,													//   
								 EMPTY													//       ,  EMPTY    
									};
//+------------------------------------------------------------------+
//|         
//|       (,  \)
//+------------------------------------------------------------------+
double	GcontPos[4];//{X_DISTANCE,Y_DISTANCE,Time,Price}
//+------------------------------------------------------------------+
//| Arial black Tahoma Courier new Times new roman Wingdings 1 2 3 Webdings
//+------------------------------------------------------------------+
//|	        ASCII			|						
//+------------------------------------------------------------------+
//|	   |  0  |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |  9  |                                                 
//+------------------------------------------------------------------+ 
//|	 3 |     |     | " " |  !  |  "  |  #  |  $  |  %  |  &  |  '  |
//|	 4 |  (  |  )  |  *  |  +  |  ,  |  -  |  .  |  /  |  0  |  1  |
//|	 5 |  2  |  3  |  4  |  5  |  6  |  7  |  8  |  9  |  :  |  ;  |
//|	 6 |  <  |  =  |  >  |  ?  |  @  |  A  |  B  |  C  |  D  |  E  |
//|	 7 |  F  |  G  |  H  |  I  |  J  |  K  |  L  |  M  |  N  |  O  |
//|	 8 |  P  |  Q  |  R  |  S  |  T  |  U  |  V  |  W  |  X  |  Y  |
//|	 9 |  Z  |  [  |  \  |  ]  |  ^  |  _  |  `  |  a  |  b  |  c  |
//|	10 |  d  |  e  |  f  |  g  |  h  |  i  |  j  |  k  |  l  |  m  |
//|	11 |  n  |  o  |  p  |  q  |  r  |  s  |  t  |  u  |  v  |  w  |
//|	12 |  x  |  y  |  z  |  {  |  |  |  }  |  ~  |  ?? |    |    |
//|	13 |    |    |    |    |    |    |    |    |    |    |
//|	14 |    |    |    |    |    |    |    |    |    |  o  |
//|	15 |  -  |    |     |    |    |    |    |    |    |    |
//|	16 |     |    |    |    |    |    |    |    |    |    |
//|	17 |    |    |    |    |    |    |    |    |    |    |
//|	18 |    |    |    |    |    |    |    |    |    |    |
//|	19 |    |    |    |    |    |    |    |    |    |    |
//|	20 |    |    |    |    |    |    |    |    |    |    |
//|	21 |    |    |    |    |    |    |    |    |    |    |
//|	22 |    |    |    |    |    |    |    |    |    |    |
//|	23 |    |    |    |    |    |    |    |    |    |    |
//|	24 |    |    |    |    |    |    |    |    |    |    |
//|	25 |    |    |    |    |    |    |     |     |     |     |
//+------------------------------------------------------------------+
//|                                 Function  :          DelControls |
//|                                 Copyright  2011, XrustSolution. |
//|                                           mail: xrustx@gmail.com |
//|	       (contNms)		|
//+------------------------------------------------------------------+
void  DelControls(int wnd=0){int i,x;
	int sz = ArrayRange(GcontNms,0);
	for(i = 0; i < sz; i++){
		string nm = GcontNms[i][0];
		if(ObjectFind(nm)>=0){ObjectDelete(nm);}
	}	
	return;	
}
//+------------------------------------------------------------------+
//|                                 Function  :           SetControl |
//|                                 Copyright  2011, XrustSolution. |
//|                                           mail: xrustx@gmail.com |
//|          |
//+------------------------------------------------------------------+
void SetControls(int wnd=0){int i,x,y;
	int sz = ArrayRange(GcontNms,0);
	for(i = 0; i <= sz; i++){
		string nm = GcontNms[i][0];
		if(ObjectFind	 (nm)!=wnd){
			ObjectCreate (nm,OBJ_LABEL,wnd,0,0);
			ObjectSet	 (nm,OBJPROP_ANGLE 	 ,0);			
			ObjectSet	 (nm,OBJPROP_BACK 	 ,false);
			ObjectSet	 (nm,OBJPROP_XDISTANCE,GcontDat[i][0]);
			ObjectSet	 (nm,OBJPROP_YDISTANCE,GcontDat[i][1]);
			ObjectSet	 (nm,OBJPROP_CORNER   ,GcontDat[i][2]);
			ObjectSet	 (nm,OBJPROP_COLOR	 ,GcontDat[i][4]);
			ObjectSetText(nm,GcontNms[i][1]	 ,GcontDat[i][3]
														 ,GcontNms[i][2]
														 ,GcontDat[i][4]);			
		}
	}   
   return;
}
//+------------------------------------------------------------------+
//|                                 Function  :           GetControl |
//|                                 Copyright  2011, XrustSolution. |
//|                                           mail: xrustx@gmail.com |
//|         . |
//|    ,     |
//|         (GcontPos)		| 
//+------------------------------------------------------------------+
int  GetControls(int wnd=0, bool activate = false){int i,x,y,a,cr;
	int sz = ArrayRange(GcontNms,0);
	for(i = 0; i < sz; i++){
		string nm = GcontNms[i][0];
		if(ObjectFind(nm)!=wnd){SetControls(wnd);return(0);}
		int xPos = ObjectGet(nm,OBJPROP_XDISTANCE);
		int yPos = ObjectGet(nm,OBJPROP_YDISTANCE);
		if(xPos!=GcontDat[i][0]||yPos!=GcontDat[i][1]){
		  	GcontPos[0] = xPos;
		  	GcontPos[1] = yPos;
			ObjectSet(nm,OBJPROP_XDISTANCE,GcontDat[i][0]);
			ObjectSet(nm,OBJPROP_YDISTANCE,GcontDat[i][1]);
			WindowRedraw();
		 	xPos = ObjectGet(nm,OBJPROP_XDISTANCE);
		 	yPos = ObjectGet(nm,OBJPROP_YDISTANCE);
		 	cr   = ObjectGet(nm,OBJPROP_CORNER); 
		 	if(xPos == GcontDat[i][0] && yPos == GcontDat[i][1]){
		 		if(GcontDat[i][5]!=EMPTY){// 
		 			int col = ObjectGet(nm,OBJPROP_COLOR);
		 			if(col == GcontDat[i][4]){//  
		 				if(GcontNms[i][3]==""){
		 					ObjectSet(nm,OBJPROP_COLOR,GcontDat[i][5]);
		 					Pos2PriceTime(cr);	 					
		 					return(i+1);
		 				}else{
		 					ObjectSet(nm,OBJPROP_COLOR,GcontDat[i][5]);
							ObjectSetText(nm,GcontNms[i][1],GcontDat[i][3],GcontNms[i][3],GcontDat[i][5]);
							Pos2PriceTime(cr);							
							return(i+1);			 					
		 				}
		 			}else{//  
		 				if(GcontNms[i][3]==""){
		 					ObjectSet(nm,OBJPROP_COLOR,GcontDat[i][4]);
		 					Pos2PriceTime(cr);		 					
		 					return(-i-1);
		 				}else{
		 					ObjectSet(nm,OBJPROP_COLOR,GcontDat[i][4]);
							ObjectSetText(nm,GcontNms[i][1],GcontDat[i][3],GcontNms[i][2],GcontDat[i][4]);
							Pos2PriceTime(cr);
							return(-i-1);		 					
		 				}		 			
		 			}
		 		}else{//  
		 			Pos2PriceTime(cr);
					if(activate){
						a=Activate(wnd,i,GcontPos[0],GcontPos[1]);
						if(a!=0){
							if(GcontDat[a][5]!=EMPTY&&a!=i){// 
								nm = GcontNms[a][0];
								col = ObjectGet(nm,OBJPROP_COLOR);
		 						if(col == GcontDat[a][4]){//  
		 							if(GcontNms[a][3]==""){
		 								ObjectSet(nm,OBJPROP_COLOR,GcontDat[a][5]);
		 								Pos2PriceTime(cr);	 					
		 								return(a+1);
		 							}else{
		 								ObjectSet(nm,OBJPROP_COLOR,GcontDat[a][5]);
										ObjectSetText(nm,GcontNms[a][1],GcontDat[a][3],GcontNms[a][3],GcontDat[a][5]);
										Pos2PriceTime(cr);							
										return(a+1);			 					
		 							}
		 						}else{//  
		 							if(GcontNms[a][3]==""){
		 								ObjectSet(nm,OBJPROP_COLOR,GcontDat[a][4]);
		 								Pos2PriceTime(cr);		 					
		 								return(-a-1);
		 							}else{
		 								ObjectSet(nm,OBJPROP_COLOR,GcontDat[a][4]);
										ObjectSetText(nm,GcontNms[a][1],GcontDat[a][3],GcontNms[a][2],GcontDat[a][4]);
										Pos2PriceTime(cr);
										return(-a-1);		 					
		 							}		 			
		 						}
		 					}						
							return(a+1);
						}
					}		 			
		 			return(i+1);
		 		}
		 	}else{
		 		return(0);
		 	}			
		}	
	}
	return(0);
}
//+------------------------------------------------------------------+
int window[4];
#import "user32.dll"
bool GetClientRect(int hWnd,int& Pos[4]);
//+------------------------------------------------------------------+
//|                                 Function  :        Pos2PriceTime |
//|                                 Copyright  2011, XrustSolution. |
//|                                           mail: xrustx@gmail.com |
//+------------------------------------------------------------------+
void	Pos2PriceTime(int corner){int i,x,y,rt,lf,tm,wt,tPoint,hWnd;double up,dn,pr,pPoint;
	GetClientRect(WindowHandle(Symbol(),Period()),window);
	up = WindowPriceMax(0);
	dn = WindowPriceMin(0);
	pPoint = NormalizeDouble(((up - dn)/Point)/((window[3]-window[1])-22),Digits);
	
	lf = WindowFirstVisibleBar();
   tPoint = (window[2]-window[0]-44)/WindowBarsPerChart();
   int pBar  = GcontPos[0]/tPoint;
   if(corner==1||corner==3){pBar=(window[2]-window[0]-44-GcontPos[0])/tPoint;}
   int pTime;
   if(lf-pBar>=0){
   	pTime = Time[lf-pBar]; 
   }else{
   	pTime = Time[0]-((lf-pBar)*Period()*60); 
   }
   GcontPos[2] = pTime;
   switch(corner){
   	case 0 :  GcontPos[3] = up-(GcontPos[1]*pPoint)*Point; break;
   	case 1 :  GcontPos[3] = up-(GcontPos[1]*pPoint)*Point; break;
   	case 2 :  GcontPos[3] = dn+(GcontPos[1]*pPoint)*Point; break;
   	case 3 :  GcontPos[3] = dn+(GcontPos[1]*pPoint)*Point; break;
   }
	return;
}
//+------------------------------------------------------------------+
//|                                 Function  :           	Activate |
//|                                 Copyright  2011, XrustSolution. |
//|                                           mail: xrustx@gmail.com |
//+------------------------------------------------------------------+
int Activate(int wnd, int cnt, int xPos, int yPos){int i,x,y,h,w,c,f;
	int sz = ArrayRange(GcontNms,0);
	if(sz==1){return(0);}
	for(i = 0; i < sz; i++){
		if(cnt==i){continue;}
		x = GcontDat[i][0];
		y = GcontDat[i][1];
		c = GcontDat[i][3];
		f = c*StringLen(GcontNms[i][1]);
		if((xPos>=x && xPos<=x+f)&&(yPos>=y && yPos<=y+c)){return(i);}	 
	}
	return(0);
}
//+------------------------------------------------------------------+